var iRating	= 0;
var sHover	= '';

function initTheme() {
    var playTrack = document.getElementById('playTrack');
    var nextTrack = document.getElementById('nextTrack');
    var prevTrack = document.getElementById('prevTrack');

    Bowtie.addMouseTrackingForElement(playTrack, 'hoverPlay');
    Bowtie.addMouseTrackingForElement(prevTrack, 'hoverPrev');
    Bowtie.addMouseTrackingForElement(nextTrack, 'hoverNext');
}

function changeAlbumArt(sUrl) {
    Bowtie.log(sUrl);
    if(sUrl !== undefined && sUrl !== '') {
        $('#album-art').attr('src', sUrl);
    } else {
        $('#album-art').attr('src', 'img/default-cover.png');
    }
}

function changeState(iState) {
    switch (iState) {
        case 1:
            $('#pauseTrack'+sHover).css('display', 'block');
            $('#playTrack'+sHover).css('display', 'none');
            break;
            
        default:
        	$('#pauseTrack'+sHover).css('display', 'none');
            $('#playTrack'+sHover).css('display', 'block');
            break;
    }
}

function playerUpdate() {
    var currentPosition     = Player.playerPosition();
    var currentTrackLength  = Player.currentTrack().length;
    var positionPercentage  = (currentPosition / currentTrackLength) * 100.0;

    $('#progress-bar').css('width', positionPercentage + '%');
}

function changeNowPlaying(oTrack) {
    $('h1').html(oTrack.propertyHTML('artist'));
    $('h2').html(oTrack.propertyHTML('title'));
    $('h3').html(oTrack.propertyHTML('album'));
    updateRating();
}

function setRating(iNewRating) {
    if (iNewRating > 0) {
        Player.setRating(iNewRating * 20);
    } else {
        Player.setRating(0);
    }

    updateRating();
}

function updateRating() {
    var sStars  = '';

    iRating     = Math.round(Player.rating() / 20);
    sStars      = '<img src="img/star-empty.png" alt="" onclick="setRating(1);" id="one" />';
    sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(2);" id="two" />';
    sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(3);" id="three" />';
    sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(4);" id="four" />';
    sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(5);" id="five" />';

    switch (iRating) {
        case 0:
        	sStars		= '<a href="#" id="zero" onclick="setRating(0); return false;"></a>';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(1);" id="one" />';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(2);" id="two" />';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(3);" id="three" />';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(4);" id="four" />';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(5);" id="five" />';
            break;
            
        case 1:
            sStars		= '<a href="#" id="zero" onclick="setRating(0); return false;"></a>';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(1);" id="one" />';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(2);" id="two" />';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(3);" id="three" />';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(4);" id="four" />';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(5);" id="five" />';
            break;

        case 2:
            sStars		= '<a href="#" id="zero" onclick="setRating(0); return false;"></a>';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(1);" id="one" />';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(2);" id="two" />';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(3);" id="three" />';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(4);" id="four" />';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(5);" id="five" />';
            break;

        case 3:
            sStars		= '<a href="#" id="zero" onclick="setRating(0); return false;"></a>';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(1);" id="one" />';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(2);" id="two" />';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(3);" id="three" />';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(4);" id="four" />';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(5);" id="five" />';
            break;

        case 4:
            sStars		= '<a href="#" id="zero" onclick="setRating(0); return false;"></a>';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(1);" id="one" />';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(2);" id="two" />';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(3);" id="three" />';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(4);" id="four" />';
            sStars     += '<img src="img/star-empty.png" alt="" onclick="setRating(5);" id="five" />';
            break;

        case 5:
            sStars		= '<a href="#" id="zero" onclick="setRating(0); return false;"></a>';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(1);" id="one" />';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(2);" id="two" />';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(3);" id="three" />';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(4);" id="four" />';
            sStars     += '<img src="img/star-full.png" class="filled" alt="" onclick="setRating(5);" id="five" />';
            break;
    }

    $('#rating').html(sStars);
}

$('#prevTrackHover').click(function() {
    Player.previousTrack();
    changeNowPlaying();
});

$('#playTrackHover').click(function() {
    Player.play();

    $('#pauseTrack'+sHover).css('display', 'block');
    $('#playTrack'+sHover).css('display', 'none');
});

$('#pauseTrackHover').click(function() {
    Player.pause();

    $('#pauseTrack'+sHover).css('display', 'none');
    $('#playTrack'+sHover).css('display', 'block');
});

$('#nextTrackHover').click(function() {
    Player.nextTrack();
    changeNowPlaying();
});

function hoverPlay(BTWrapper) {
    switch (Player.playState()) {
        case 1:
            if (BTWrapper.property('enter')) {
                sHover = 'Hover';
                $('#pauseTrack').css('display', 'none');
                $('#pauseTrackHover').css('display', 'block');
            } else {
                sHover = '';
                $('#pauseTrack').css('display', 'block');
                $('#pauseTrackHover').css('display', 'none');
            }
            $('#playTrack').css('display', 'none');
            $('#playTrackHover').css('display', 'none');
            break;

        default:
            if (BTWrapper.property('enter')) {
                sHover = 'Hover';
                $('#playTrack').css('display', 'none');
                $('#playTrackHover').css('display', 'block');
            } else {
                sHover = '';
                $('#playTrack').css('display', 'block');
                $('#playTrackHover').css('display', 'none');
            }
            $('#pauseTrack').css('display', 'none');
            $('#pauseTrackHover').css('display', 'none');
            break;
    }
}

function hoverNext(BTWrapper) {
    if (BTWrapper.property('enter')) {
        sHover = 'Hover';
        $('#nextTrack').css('display', 'none');
        $('#nextTrackHover').css('display', 'block');
    } else {
        sHover = '';
        $('#nextTrack').css('display', 'block');
        $('#nextTrackHover').css('display', 'none');
    }
}

function hoverPrev(BTWrapper) {
    if (BTWrapper.property('enter')) {
        sHover = 'Hover';
        $('#prevTrack').css('display', 'none');
        $('#prevTrackHover').css('display', 'block');
    } else {
        sHover = '';
        $('#prevTrack').css('display', 'block');
        $('#prevTrackHover').css('display', 'none');
    }
}
